/* Copyright (c) 2009, Code Aurora Forum. All rights reserved.
 * This software is contributed or developed by KYOCERA Corporation.
 * (C) 2011 KYOCERA Corporation
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above
 *       copyright notice, this list of conditions and the following
 *       disclaimer in the documentation and/or other materials provided
 *       with the distribution.
 *     * Neither the name of Code Aurora Forum, Inc. nor the names of its
 *       contributors may be used to endorse or promote products derived
 *       from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */


#ifndef __MSM_BATTERY_H__
#define __MSM_BATTERY_H__

#define AC_CHG     0x00000001
#define USB_CHG    0x00000002

struct msm_psy_batt_pdata {
	u32 voltage_max_design;
	u32 voltage_min_design;
	u32 avail_chg_sources;
	u32 batt_technology;
	u32 (*calculate_capacity)(u32 voltage);
};


extern void update_msm_batt_status(void);



typedef enum {
	DEV_INFO_CAM_OFF,
	DEV_INFO_CAM_PREVIEW,
	DEV_INFO_MOVIE_PREVIEW,
	DEV_INFO_MOVIE_REC_HIGH,
	DEV_INFO_MOVIE_REC_MEDIUM_WIDE,
	DEV_INFO_MOVIE_REC_MEDIUM,
	DEV_INFO_MOVIE_REC_LOW,
	DEV_INFO_CAM_STATE_MAX
} dev_info_cam_state_type;

typedef enum {
	DEV_INFO_SND_OFF,
	DEV_INFO_SND_SPEAKER,
	DEV_INFO_SND_RECEIVER,
	DEV_INFO_SND_HEADSET,
	DEV_INFO_SND_STATE_MAX
} dev_info_snd_state_type;

typedef enum {
	DEV_INFO_WLAN_OFF,
	DEV_INFO_WLAN_ON,
	DEV_INFO_WLAN_STATE_MAX
} dev_info_wlan_state_type;

extern void msm_batt_oem_update_dev_info_lcd_lv( u32 lv, int updown );

extern void msm_batt_oem_update_dev_info_lcd_onoff( bool onoff );

extern void msm_batt_oem_update_dev_info_cam( dev_info_cam_state_type cam_st );

extern void msm_batt_oem_update_dev_info_snd( dev_info_snd_state_type snd_st, bool onoff );

extern void msm_batt_oem_update_dev_info_wlan( dev_info_wlan_state_type wlan_st );


#endif
