/*
 * This software is contributed or developed by KYOCERA Corporation.
 * (C) 2011 KYOCERA Corporation
 */

#ifndef S5K4EAG_H
#define S5K4EAG_H

#include <mach/board.h>
#include <mach/camera.h>

#define TRUE  1
#define FALSE 0

#define CAMSENSOR_DEBUG
#undef CAMSENSOR_DEBUG

#define REG_C6P

#ifdef REG_C6P
  #define REG_C20P

#endif

extern struct cam_reg_t cam_regs;

enum cam_width_t {

#if(0)
  BYTE_LEN,
	WORD_LEN,
#else
	BYTE_LEN,
	WORD_LEN,
	ADWORD_DATBYTE_LEN,
	ADWORD_DATWORD_LEN,
	ADWORD_DATLONG_LEN,
#endif

};

struct cam_i2c_reg_conf {
	unsigned short waddr;

	unsigned long wdata;
	enum cam_width_t width;
	unsigned short mdelay_time;
};

#ifdef CAMSENSOR_DEBUG
struct cam_i2c_reg_debug_conf {
	unsigned int waddr;
	unsigned short wdata;
	enum cam_width_t width;
	unsigned short mdelay_time;
};
#endif

struct cam_reg_t {
  unsigned short hw_ver_addr;
  unsigned short rev_ver_addr;

    struct cam_i2c_reg_conf const *preview_sxga_init_reg_settings_1;
    uint16_t preview_sxga_init_reg_settings_1_size;
    struct cam_i2c_reg_conf const *preview_sxga_init_reg_settings_2;
    uint16_t preview_sxga_init_reg_settings_2_size;
    struct cam_i2c_reg_conf *preview_sxga_init_reg_settings_4;
    uint16_t preview_sxga_init_reg_settings_4_size;
    struct cam_i2c_reg_conf const *preview_sxga_init_reg_settings_5;
    uint16_t preview_sxga_init_reg_settings_5_size;

    struct cam_i2c_reg_conf const *preview_720p_init_reg_settings_1;
    uint16_t preview_720p_init_reg_settings_1_size;
    struct cam_i2c_reg_conf const *preview_720p_init_reg_settings_2;
    uint16_t preview_720p_init_reg_settings_2_size;
    struct cam_i2c_reg_conf *preview_720p_init_reg_settings_4;
    uint16_t preview_720p_init_reg_settings_4_size;
    struct cam_i2c_reg_conf const *preview_720p_init_reg_settings_5;
    uint16_t preview_720p_init_reg_settings_5_size;

    struct cam_i2c_reg_conf const *preview_wvga_init_reg_settings_1;
    uint16_t preview_wvga_init_reg_settings_1_size;
    struct cam_i2c_reg_conf const *preview_wvga_init_reg_settings_2;
    uint16_t preview_wvga_init_reg_settings_2_size;
    struct cam_i2c_reg_conf *preview_wvga_init_reg_settings_4;
    uint16_t preview_wvga_init_reg_settings_4_size;
    struct cam_i2c_reg_conf const *preview_wvga_init_reg_settings_5;
    uint16_t preview_wvga_init_reg_settings_5_size;

    struct cam_i2c_reg_conf const *preview_vga_init_reg_settings_1;
    uint16_t preview_vga_init_reg_settings_1_size;
    struct cam_i2c_reg_conf const *preview_vga_init_reg_settings_2;
    uint16_t preview_vga_init_reg_settings_2_size;
    struct cam_i2c_reg_conf *preview_vga_init_reg_settings_4;
    uint16_t preview_vga_init_reg_settings_4_size;
    struct cam_i2c_reg_conf const *preview_vga_init_reg_settings_5;
    uint16_t preview_vga_init_reg_settings_5_size;

    struct cam_i2c_reg_conf const *dlc_vga_init_reg_settings_1;
    uint16_t dlc_vga_init_reg_settings_1_size;
    struct cam_i2c_reg_conf const *dlc_vga_init_reg_settings_2;
    uint16_t dlc_vga_init_reg_settings_2_size;
    struct cam_i2c_reg_conf *dlc_vga_init_reg_settings_4;
    uint16_t dlc_vga_init_reg_settings_4_size;
    struct cam_i2c_reg_conf const *dlc_vga_init_reg_settings_5;
    uint16_t dlc_vga_init_reg_settings_5_size;

    struct cam_i2c_reg_conf const *init_write_rom_correction;
    uint16_t init_write_rom_correction_size;
    struct cam_i2c_reg_conf const *af_driver_data;
    uint16_t af_driver_data_size;

    struct cam_i2c_reg_conf const *jpeg_still_reg_settings;
    uint16_t jpeg_still_reg_settings_size;

    struct cam_i2c_reg_conf const *still_to_preview_reg_settings;
    uint16_t still_to_preview_reg_settings_size;

    struct cam_i2c_reg_conf const *preview_720p_reg_settings;
    uint16_t preview_720p_reg_settings_size;

    struct cam_i2c_reg_conf const *preview_wvga_reg_settings;
    uint16_t preview_wvga_reg_settings_size;

    struct cam_i2c_reg_conf const *af_inf_to_macro_start;
    uint16_t af_inf_to_macro_start_reg_setting_size;

    struct cam_i2c_reg_conf const *af_macro_to_inf_start;
    uint16_t af_macro_to_inf_start_reg_setting_size;

    struct cam_i2c_reg_conf const *set_wb_reg;
    uint16_t set_wb_reg_size;
    struct cam_i2c_reg_conf const *set_effect_reg;
    uint16_t set_effect_reg_size;
    struct cam_i2c_reg_conf const *set_iso_reg;
    uint16_t set_iso_reg_size;
    struct cam_i2c_reg_conf const *set_aec_mode_reg;
    uint16_t set_aec_mode_reg_size;

    struct cam_i2c_reg_conf *set_scene_auto_reg;
    uint16_t set_scene_auto_reg_size;
    struct cam_i2c_reg_conf *set_scene_portrait_reg;
    uint16_t set_scene_portrait_reg_size;
    struct cam_i2c_reg_conf *set_scene_scenery_reg;
    uint16_t set_scene_scenery_reg_size;
    struct cam_i2c_reg_conf *set_scene_night_portrait_reg;
    uint16_t set_scene_night_portrait_reg_size;
    struct cam_i2c_reg_conf *set_scene_night_scenery_reg;
    uint16_t set_scene_night_scenery_reg_size;
    struct cam_i2c_reg_conf *set_scene_action_reg;
    uint16_t set_scene_action_reg_size;

    struct cam_i2c_reg_conf const *dlc_mode;
    uint16_t dlc_mode_reg_settings_size;

};

void cam_set_flash_debug_mode(int);

#define AF_FLASH_BB_CHECK
#undef AF_FLASH_BB_CHECK

#ifdef CAMSENSOR_DEBUG
void cam_set_flash_debug_mode(int);
#endif

#ifdef AF_FLASH_BB_CHECK
#define FL1_IN_GPIO     156
#define AF_CHK_GPIO     107

#define BB_CHK_AF         0
#define BB_CHK_STILL      1

int cam_af_flash_bb_check(unsigned mode, unsigned on_off);

#endif

#endif
